/*
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	The author can be contacted at:
	Donald Graft
	neuron2@attbi.com.
*/

#ifdef AVISYNTH25
#include "internal.h"
#else
#include "avisynth.h"
#endif

AVSValue __cdecl Create_Telecide(AVSValue args, void* user_data, IScriptEnvironment* env);
AVSValue __cdecl Create_FieldDeinterlace(AVSValue args, void* user_data, IScriptEnvironment* env);
AVSValue __cdecl Create_Decimate(AVSValue args, void* user_data, IScriptEnvironment* env);

#ifdef AVISYNTH25
extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env)
#else
extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit(IScriptEnvironment* env)
#endif
{
    env->AddFunction("Telecide",
					 "c[mm]i[reverse]b[swap]b[firstlast]b[guide]i[gthresh]i[agg]b[nt]i[post]b[threshold]i[dthreshold]i[blend]b[chroma]b[y0]i[y1]i[ovr]s[show]b[debug]b",
		             Create_Telecide, 0);
	env->AddFunction("FieldDeinterlace", "c[full]b[threshold]i[dthreshold]i[blend]b[chroma]b[ovr]s[show]b[debug]b", Create_FieldDeinterlace, 0);
    env->AddFunction("Decimate", "c[cycle]i[mode]i[threshold]f[threshold2]f[quality]i[ovr]s[show]b[debug]b", Create_Decimate, 0);
	return 0;
}
